#pragma once


#ifdef HAPTICS_CHAI
	#define HAPTIC_NAME "chai3d"
#elif defined HAPTICS_HDAL
	#define HAPTIC_NAME "HDAL"
#else
	#define HAPTIC_NAME "unknown"
#endif



#ifdef HAPTICS_CHAI
	extern cMeta3dofPointer *tool;
	extern cWorld *world;
	extern cPrecisionTimer hapticTimer;
	
	void callbackContact(void *unusedParam);
#endif
#ifdef HAPTICS_HDAL
	extern HDLDeviceHandle deviceHandle;	//handle to Falcon device
	extern HDLOpHandle callbackHandle;	//handle to continuous haptic callback
	extern double deviceWorkspace[6],workspace[6];
	extern double transformFromDevice[16];	//matrix transforming position from device coordinates to world coodinates
	//For explanation of *Servo variable duplicates, refer to HDAL programming guide
	extern double toolPositionServo[3];
	extern double toolForceServo[3],toolForce[3];
	
	HDLServoOpExitCode callbackContact(void *unusedParam);	//continuous callback
	HDLServoOpExitCode callbackSynchronize(void *unusedParam);	//callback to synchronize app variables with servo variables
	void deviceToWorld(const double device[3],double world[3]);	//transform position using transformToDevice[]
#endif



extern GLfloat thicknessServo,thickness;	//0.0-1.0 range measure of large sphere penetration
extern double toolPosition[3];



void initHaptics();
void uninitHaptics();
void updateTool();	//update app data about device from haptic data
void callbackContact(const double position[3],double force[3]);	//actual force computation
const double* getToolPosition();	//returns app data about device position
